GET/cosmos/gov/v1beta1/proposals

https://rest-cronospos-mainnet.nodit.io/cosmos/gov/v1beta1/proposals

Proposals queries all proposals based on given status.

Query Parameters
proposal_statusstring (enum)

proposal_status defines the status of the proposals.

  • PROPOSAL_STATUS_UNSPECIFIED: PROPOSAL_STATUS_UNSPECIFIED defines the default proposal status.
  • PROPOSAL_STATUS_DEPOSIT_PERIOD: PROPOSAL_STATUS_DEPOSIT_PERIOD defines a proposal status during the deposit period.
  • PROPOSAL_STATUS_VOTING_PERIOD: PROPOSAL_STATUS_VOTING_PERIOD defines a proposal status during the voting period.
  • PROPOSAL_STATUS_PASSED: PROPOSAL_STATUS_PASSED defines a proposal status of a proposal that has passed.
  • PROPOSAL_STATUS_REJECTED: PROPOSAL_STATUS_REJECTED defines a proposal status of a proposal that has been rejected.
  • PROPOSAL_STATUS_FAILED: PROPOSAL_STATUS_FAILED defines a proposal status of a proposal that has failed.
voterstring

voter defines the voter address for the proposals.

depositorstring

depositor defines the deposit addresses from the proposals.

pagination.keystring (byte)

key is a value returned in PageResponse.next_key to begin querying the next page most efficiently. Only one of offset or key should be set.

pagination.offsetstring (uint64)

offset is a numeric offset that can be used when key is unavailable. It is less efficient than using key. Only one of offset or key should be set.

pagination.limitstring (uint64)

limit is the total number of results to be returned in the result page. If left empty it will default to a value to be set by each app.

pagination.count_totalboolean

count_total is set to true to indicate that the result set should include a count of the total number of items available for pagination in UIs. count_total is only respected when offset is used. It is ignored when key is set.

pagination.reverseboolean

Set to true to return results in descending order.

Responses
proposal_idstring (uint64)

proposal_id is the unique id of a proposal.

contentobject

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}

Example 3: Pack and unpack a message in Python.

foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...

Example 4: Pack and unpack a message in Go

 foo := &pb.Foo{...}
 any, err := anypb.New(foo)
 if err != nil {
   ...
 }
 ...
 foo := &pb.Foo{}
 if err := any.UnmarshalTo(foo); err != nil {
   ...
 }

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

JSON

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}

{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
type_urlstring

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one "/" character. The last segment of the URL's path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading "." is not accepted).

In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows:

  • If no scheme is provided, https is assumed.
  • An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error.
  • Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.)

Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com.

Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

valuestring (byte)

Must be a valid serialized protocol buffer of the above specified type.

statusstring (enum)

status defines the proposal status.

final_tally_resultobject

final_tally_result is the final tally result of the proposal. When querying a proposal via gRPC, this field is not populated until the proposal's voting period has ended.

yesstring

yes is the number of yes votes on a proposal.

abstainstring

abstain is the number of abstain votes on a proposal.

nostring

no is the number of no votes on a proposal.

no_with_vetostring

no_with_veto is the number of no with veto votes on a proposal.

submit_timestring (date-time)

submit_time is the time of proposal submission.

deposit_end_timestring (date-time)

deposit_end_time is the end time for deposition.

total_depositobject[]

total_deposit is the total deposit on the proposal.

denomstring

Token denomination.

amountstring

Amount, as an integer string in the smallest unit.

voting_start_timestring (date-time)

voting_start_time is the starting time to vote on a proposal.

voting_end_timestring (date-time)

voting_end_time is the end time of voting on a proposal.

next_keystring (byte)

next_key is the key to be passed to PageRequest.key to query the next page most efficiently. It will be empty if there are no more results.

totalstring (uint64)

Total number of results. Populated only when pagination.count_total is set in the request.

X-API-KEY
RequestCU35
cURL
curl -X GET "https://rest-cronospos-mainnet.nodit.io/cosmos/gov/v1beta1/proposals?proposal_status=PROPOSAL_STATUS_UNSPECIFIED&voter=string&depositor=string&pagination.key=string&pagination.offset=string&pagination.limit=string&pagination.count_total=true&pagination.reverse=true" \
  -H "X-API-KEY: {YOUR_API_KEY}"
Response
Example · 200
{
  "proposals": [
    {
      "proposal_id": "string",
      "content": {
        "type_url": "string",
        "value": "string"
      },
      "status": "PROPOSAL_STATUS_UNSPECIFIED",
      "final_tally_result": {
        "yes": "string",
        "abstain": "string",
        "no": "string",
        "no_with_veto": "string"
      },
      "submit_time": "string",
      "deposit_end_time": "string",
      "total_deposit": [
        {}
      ],
      "voting_start_time": "string",
      "voting_end_time": "string"
    }
  ],
  "pagination": {
    "next_key": "string",
    "total": "string"
  }
}